/*
 * Makarov Alex
 * alexd.makarov@gmail.com
 * DSI
 */

package ru.dsi.bgbilling.robokassa.util;

import javax.mail.*;
import javax.mail.internet.*;
import java.util.Properties;
import java.io.FileInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 *
 * @author makarovad
 */
public class Mailme {

    //private static String robopropFile = "d://robokassa.properties"; //Для тестирования
    private static String robopropFile = "/usr/local/BGBillingServer/data/robokassa.properties"; //Для использования на сервере BGBilling

    public void sendMail(String messageBode, String messageSubject)throws NoSuchProviderException,
                                                                          MessagingException {
        try{
            File f = new File(robopropFile);
            FileInputStream fis = new FileInputStream(f);        
            Properties prop = new Properties();
            prop.load(fis);
            fis.close();
            String mailSender = prop.getProperty("mailSender");
            String mailSenderUser = prop.getProperty("mailSenderUser");
            String mailSenderPass = prop.getProperty("mailSenderPass");
            String recipients = prop.getProperty("mailRecipients");

            Properties props = new Properties();
            props.setProperty("mail.transport.protocol", "smtp");
            props.setProperty("mail.host", mailSender);
            props.setProperty("mail.from", mailSenderUser);
            props.setProperty("mail.user", "");
            props.setProperty("mail.password", mailSenderPass);
            Session mailSession = Session.getDefaultInstance(props, null);
            Transport transport = mailSession.getTransport();
            MimeMessage message = new MimeMessage(mailSession);
            message.setSubject(messageSubject);
            message.setContent(messageBode, "text/plain");        
            message.addRecipients(Message.RecipientType.TO, recipients);
            transport.connect();
            transport.sendMessage(message,
            message.getRecipients(Message.RecipientType.TO));
            transport.close();    
        }catch(FileNotFoundException e){
            e.printStackTrace();
        }catch(IOException e){
            e.printStackTrace();
        }

    }

}
