/*
 * Makarov Alex
 * alexd.makarov@gmail.com
 * DSI
 */

package ru.dsi.bgbilling.robokassa.util;

import org.apache.commons.codec.digest.DigestUtils;
import java.util.Properties;
import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;



/**
 *
 * @author makarovad
 */
public class md5 {

    private static Properties props = new Properties();
    private static String file_path  = "/usr/local/BGBillingServer/data/robokassa.properties";
    //private static String file_path  = "d://robokassa.properties";

/**
 * Возвратит зашифрованную строку в HEX. Входные параметры образуют строку,
 * которая в свою очереь и подвергается шифрованию.
 * Первый параметр это сума платежа,
 * Второй уникальный счет платежной системы (в нашем случае это 0)
 * Третий параметр это идентификатор нашего договора в биллинге
 *
 * @param  Сумма платежа
 * @param  Иденификатор платежа в платежной системе
 * @param  Иденификатор договора в биллинге
 * @return Зашифрованная строка по алгоритму MD5
 * @see    String
 */
    public String toR(){
        return "1";
    }

    public static String md5d(String sum_o, String cid, String shp_item){
        String md5hex;        
        try{
            File propsFile = new File(file_path);
            FileInputStream fis = new FileInputStream(propsFile);
            props.load(fis);
            fis.close();            
            String user_pass = props.getProperty("mrh_pass2");                        
            md5hex = DigestUtils.md5Hex(sum_o+":"+cid+":"+user_pass+":shp_contract="+shp_item).toUpperCase();
        }catch(FileNotFoundException e){
            System.out.println("Properties file "+file_path+" not found");
            e.printStackTrace();
            return null;
        }catch(IOException e){
            e.printStackTrace();
            return null;
        }
        return md5hex;    
    }
    public static String md5c(String sum_o, String cid, String shp_item){
        String md5hex;        
        try{
            File propsFile = new File(file_path);
            FileInputStream fis = new FileInputStream(propsFile);
            props.load(fis);
            fis.close();
            String user_name1 = props.getProperty("mrh_login");
            String user_pass = props.getProperty("mrh_pass1");                        
            md5hex = DigestUtils.md5Hex(user_name1+":"+sum_o+":"+cid+":"+user_pass+":shp_contract="+shp_item).toUpperCase();
        }catch(FileNotFoundException e){
            System.out.println("Properties file "+file_path+" not found");
            e.printStackTrace();
            return null;
        }catch(IOException e){
            e.printStackTrace();
            return null;
        }
        return md5hex;
    }

    public static String md5c4xml(int invid){
        String md5hex;
        try{
            File propsFile = new File(file_path);
            FileInputStream fis = new FileInputStream(propsFile);
            props.load(fis);
            fis.close();
            String user_name1 = props.getProperty("mrh_login");
            String user_pass = props.getProperty("mrh_pass2");
            md5hex = DigestUtils.md5Hex(user_name1+":"+invid+":"+user_pass).toUpperCase();
        }catch(FileNotFoundException e){
            System.out.println("Properties file "+file_path+" not found");
            e.printStackTrace();
            return null;
        }catch(IOException e){
            e.printStackTrace();
            return null;
        }
        return md5hex;
    }

    public static String getMrthLogin(){
        String mrhLogin;
        try{
            File propsFile = new File(file_path);
            FileInputStream fis = new FileInputStream(propsFile);
            props.load(fis);
            fis.close();
            mrhLogin = props.getProperty("mrh_login");
        }catch(FileNotFoundException e){
            System.out.println("Properties file "+file_path+" not found");
            e.printStackTrace();
            return null;
        }catch(IOException e){
            e.printStackTrace();
            return null;
        }
        return mrhLogin;
    }
}

